/* Copyright (c) 1999-2003 Mark W. McClelland, David Brownell
 * http://alpha.dyndns.org/ov511/
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. NO WARRANTY OF ANY KIND is expressed or implied.
 */

#ifndef __LINUX_OVDEBUG_H
#define __LINUX_OVDEBUG_H

# if 1
# include	<linux/usb.h>	/* strangely enough, where 'err','info' and 'warn' come from */
# else
#if !defined(err)
#define err(format, arg...) printk(KERN_ERR __FILE__ ": " format "\n" , ## arg)
#endif

#if !defined(info)
#define info(format, arg...) printk(KERN_INFO __FILE__ ": " format "\n" , \
 ## arg)
#endif

#if !defined(warn)
#define warn(format, arg...) printk(KERN_WARNING __FILE__ ": " format "\n" , \
 ## arg)
#endif
# endif

#ifdef MODULE_DEBUG
#define FNCSHIFT	4	/* best if this is 4,8,12 etc */
#define LMASK		((1 << FNCSHIFT) - 1)
#define MISC		(0x01 << FNCSHIFT)
#define FRAMESTATE	(0x02 << FNCSHIFT)
#define INCOMING	(0x04 << FNCSHIFT)
#define OUTGOING	(0x08 << FNCSHIFT)
#define IOCTL		(0x10 << FNCSHIFT)	/* debug=0x10x */
#define FNCS		(0x20 << FNCSHIFT)	/* debug=0x20x */
#define BOMB		(0x40 << FNCSHIFT)	/* debug=0x40x */

	#define PDEBUG(level, fmt, args...) \
		if ((debug & (level) & ~LMASK) != 0 && (debug & LMASK) >= ((level) & LMASK)) \
			info("[%s:%d] " fmt, __PRETTY_FUNCTION__, __LINE__ , ## args)
#else
	#define PDEBUG(level, fmt, args...) do {} while(0)
#endif

#endif /* __LINUX_OVDEBUG_H */
