/*
 * Outer layer of a driver for XL Imaging's 2.1 Megapixel USB Camera.
 * (Uses the Omnivision OV2610 sensor chips and Omnivision's "FX2-9000" USB bridge
 * chip).
 *
 * Copyright (c) 2004 Steve Hosgood <steve@caederus.com>
 * Copyright (c) 2004 XL Imaging Ltd, Singleton Park, Swansea SA2 8PP, United Kingdom.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version. NO WARRANTY OF ANY KIND is expressed or implied.
 */

# ifndef __LINUX_XLI_2M_H
# define __LINUX_XLI_2M_H

# include	<linux/config.h>
# include	<asm/uaccess.h>
# include	<linux/videodev.h>
# include	<linux/smp_lock.h>
# include	<linux/usb.h>
# include	<linux/i2c.h>

# include	"ovfx2.h"

/* Size of usb_make_path() buffer */
#define XLI_USB_PATH_LEN	64


struct usb_xli_2M {
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 5, 36)
	struct usb_interface *intf;
#else
	struct usb_device *dev;
#endif
	char usb_path[XLI_USB_PATH_LEN];
	struct video_device *vdev;	/* pointer to V4L device */
	struct usb_ovfx2 *bridge;	/* pointer to FX2 bridge info */

	struct semaphore lock;		/* Serializes user-accessible operations */
	int user;			/* user count for exclusive use */
	volatile int present;		/* Device is plugged in */

};

#endif /*  __LINUX_XLI_2M_H */
